Index: issm/trunk/src/m/classes/solidearthsettings.m
===================================================================
--- issm/trunk/src/m/classes/solidearthsettings.m	(revision 25994)
+++ issm/trunk/src/m/classes/solidearthsettings.m	(revision 26744)
@@ -5,20 +5,46 @@
 
 classdef solidearthsettings
-	properties (SetAccess=public) 
+	properties (SetAccess=public)
 		reltol                 = 0;
 		abstol                 = 0;
 		maxiter                = 0;
-		rigid                  = 0;
-		elastic                = 0;
-		rotation               = 0;
+		selfattraction         = 1;
+		elastic                = 1;
+		viscous                = 1;
+		rotation               = 1;
+		grdocean               = 1;
 		ocean_area_scaling     = 0;
 		runfrequency           = 1; %how many time steps we skip before we run grd_core
-		computesealevelchange  = 1; %will sea-level be coputed? 
-		isgrd                  = 1; %will GRD patterns be computed? 
-		degacc                 = 0; %degree increment for resolution of Green tables
+		sealevelloading        = 1; %will sea-level loads be computed? 
+		isgrd                  = 0; %will GRD patterns be computed? 
+		compute_bp_grd         = 0; %will GRD patterns for bottom pressures be computed? 
+		degacc                 = 0; %degree increment for resolution of Green tables.
+		timeacc                = 0; %time step accuracy required to compute Green tables
 		horiz                  = 0; %compute horizontal deformation
-		glfraction             = 1; %barystatic contribution full or fractional (default fractional)
+		grdmodel               = 0; %grd model (0 by default, 1 for (visco-)elastic, 2 for Ivins)
+		cross_section_shape    = 0; %cross section only used when grd model is Ivins
+	end
+	methods (Static)
+		function self = loadobj(self) % {{{
+			% This function is directly called by matlab when a model object is
+			% loaded. If the input is a struct it is an old version of this class and
+			% old fields must be recovered (make sure they are in the deprecated
+			% model properties)
+
+			if isstruct(self)
+				% 2021, Jun 4
+				if isfield(self,'rigid')
+					self.selfattraction = self.rigid;
+				end
+				if isfield(self,'computesealevelchange')
+					self.sealevelloading = self.computesealevelchange;
+				end
+				self = structtoobj(solidearthsettings(),self);
+
+			end
+		end% }}}
 	end
 	methods
+
 		function self = solidearthsettings(varargin) % {{{
 			switch nargin
@@ -30,35 +56,64 @@
 		end % }}}
 		function self = setdefaultparameters(self) % {{{
-		
-		%Convergence criterion: absolute, relative and residual
-		self.reltol=0.01; % 1 per cent 
-		self.abstol=NaN;  % default 
 
-		%maximum of non-linear iterations.
-		self.maxiter=5;
+			%Convergence criterion: absolute, relative and residual
+			self.reltol=0.01; % 1 percent
+			self.abstol=NaN;  % default
 
-		%computational flags: 
-		self.rigid=1;
-		self.elastic=1;
-		self.rotation=1;
-		self.ocean_area_scaling=0;
-		self.isgrd=1;
-		self.computesealevelchange=1;
+			%maximum of non-linear iterations.
+			self.maxiter=5;
 
-		%numerical discretization accuracy
-		self.degacc=.01;
+			%computational flags:
+			self.selfattraction=1;
+			self.elastic=1;
+			self.viscous=1;
+			self.rotation=1;
+			self.grdocean=1;
+			self.ocean_area_scaling=0;
+			self.compute_bp_grd=0;
+			self.isgrd=0;
+			self.sealevelloading=1;
 
-		%how many time steps we skip before we run solidearthsettings solver during transient
-		self.runfrequency=1;
-		
-		%fractional contribution: 
-		self.glfraction=1;
-	
-		%horizontal displacement?  (not by default)
-		self.horiz=0;
+			%numerical discretization accuracy
+			self.degacc=.01;
+			self.timeacc=1; 
+
+			%how many time steps we skip before we run solidearthsettings solver during transient
+			self.runfrequency=1;
+
+			%horizontal displacement? (not on by default)
+			self.horiz=0;
+
+			%cross section for Ivins model
+			self.cross_section_shape=1; %square as default (see iedge in GiaDeflectionCorex)
+
+			%no grd model by default:
+			self.grdmodel=0;
+
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   solidearth settings:'));
+
+			fielddisplay(self,'reltol','sea level change relative convergence criterion (default, NaN: not applied)');
+			fielddisplay(self,'abstol','sea level change absolute convergence criterion(default, NaN: not applied)');
+			fielddisplay(self,'maxiter','maximum number of nonlinear iterations');
+			fielddisplay(self,'grdocean','does this planet have an ocean, if set to 1: global water mass is conserved in GRD module (default: 1)'); 
+			fielddisplay(self,'ocean_area_scaling','correction for model representation of ocean area (default: No correction)'); 
+			fielddisplay(self,'sealevelloading','enables surface loading from sea-level change (default: 1)');
+			fielddisplay(self,'isgrd','compute GRD patterns (default: 1)');
+			fielddisplay(self,'compute_bp_grd','compute GRD patterns for bottom pressure loads (default: 1)');
+			fielddisplay(self,'runfrequency','how many time steps we skip before we run solidearthsettings solver during transient (default: 1)');
+			fielddisplay(self,'selfattraction','enables surface mass load to perturb the gravity field');
+			fielddisplay(self,'elastic','enables elastic deformation from surface loading');
+			fielddisplay(self,'viscous','enables viscous deformation from surface loading');
+			fielddisplay(self,'rotation','enables polar motion to feedback on the GRD fields');
+			fielddisplay(self,'degacc','accuracy (default: .01 deg) for numerical discretization of the Green''s functions');
+			fielddisplay(self,'timeacc','time accuracy (default: 1 yr) for numerical discretization of the Green''s functions');
+			fielddisplay(self,'grdmodel','type of deformation model, 0 for no GRD, 1 for spherical GRD model (SESAW model), 2 for half-space planar GRD (visco-elastic model from Ivins)');
+			fielddisplay(self,'cross_section_shape','1: square-edged (default). 2: elliptical. See iedge in GiaDeflectionCore');
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			if ~ismember('SealevelriseAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslr==0), 
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslc==0), 
 				return; 
 			end
@@ -68,41 +123,36 @@
 			md = checkfield(md,'fieldname','solidearth.settings.runfrequency','size',[1 1],'>=',1);
 			md = checkfield(md,'fieldname','solidearth.settings.degacc','size',[1 1],'>=',1e-10);
+			md = checkfield(md,'fieldname','solidearth.settings.timeacc','size',[1 1],'>',0);
 			md = checkfield(md,'fieldname','solidearth.settings.horiz','NaN',1,'Inf',1,'values',[0 1]);
-			md = checkfield(md,'fieldname','solidearth.settings.glfraction','values',[0 1]);
+			md = checkfield(md,'fieldname','solidearth.settings.grdmodel','>=',0,'<=',2);
+			md = checkfield(md,'fieldname','solidearth.settings.cross_section_shape','numel',[1],'values',[1,2]);
 
-			%checks on computational flags
-			if self.elastic==1 & self.rigid==0,
-				error('solidearthsettings checkconsistency error message: need rigid on if elastic flag is set');
+			if self.elastic==1 & self.selfattraction==0,
+				error('solidearthsettings checkconsistency error message: need selfattraction on if elastic flag is set');
+			end
+			if self.viscous==1 & self.elastic==0,
+				error('solidearthsettings checkconsistency error message: need elastic on if viscous flag is set');
 			end
 
-			%a coupler to a planet model is provided. 
+			%a GRD computation has been requested, make some checks on the nature of the meshes provided. 
 			if self.isgrd,
-				if md.transient.iscoupler, 
-					%we are good; 
+				if strcmpi(class(md.mesh),'mesh3dsurface'),
+					if self.grdmodel==2,
+						error('model requires a 2D mesh to run gia Ivins computations (change mesh from mesh3dsurface to mesh2d)');
+					end
 				else
-					if strcmpi(class(md.mesh),'mesh3dsurface'),
-						%we are good
-					else
-						error('model is requesting sealevel computations without being a mesh3dsurface, or being coupled to one!');
+					if self.grdmodel==1,
+						error('model requires a 3D surface mesh to run GRD computations (change mesh from mesh2d to mesh3dsurface)');
 					end
+				end
+				if self.sealevelloading==1 & self.grdocean==0
+					error('solidearthsettings checkconsistency error message: need grdocean on if sealevelloading flag is set');
 				end
 			end
 
-		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   solidearth settings:'));
+			if self.compute_bp_grd==1 & md.solidearth.settings.isgrd==0,
+					error('solidearthsettings checkconsistency error message; if bottom pressure grd patterns are requested, solidearth settings class should have isgrd flag on');
+			end
 
-			fielddisplay(self,'reltol','sea level rise relative convergence criterion, (default, NaN: not applied)');
-			fielddisplay(self,'abstol','sea level rise absolute convergence criterion, NaN: not applied');
-			fielddisplay(self,'maxiter','maximum number of nonlinear iterations');
-			fielddisplay(self,'ocean_area_scaling','correction for model representation of ocean area [default: No correction]'); 
-			fielddisplay(self,'computesealevelchange','compute sealevel change (default 1)');
-			fielddisplay(self,'isgrd','compute GRD patterns (default 1)');
-			fielddisplay(self,'runfrequency','how many time steps we skip before we run solidearthsettings solver during transient (default: 1)');
-			fielddisplay(self,'rigid','rigid earth graviational potential perturbation');
-			fielddisplay(self,'elastic','elastic earth graviational potential perturbation');
-			fielddisplay(self,'rotation','earth rotational potential perturbation');
-			fielddisplay(self,'degacc','accuracy (default .01 deg) for numerical discretization of the Green''s functions');
-			fielddisplay(self,'glfraction','contribute fractionally (default, 1) to barystatic sea level');
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -110,30 +160,38 @@
 			WriteData(fid,prefix,'object',self,'fieldname','abstol','name','md.solidearth.settings.abstol','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','maxiter','name','md.solidearth.settings.maxiter','format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','rigid','name','md.solidearth.settings.rigid','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','selfattraction','name','md.solidearth.settings.selfattraction','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','elastic','name','md.solidearth.settings.elastic','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','viscous','name','md.solidearth.settings.viscous','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','rotation','name','md.solidearth.settings.rotation','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','grdocean','name','md.solidearth.settings.grdocean','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','ocean_area_scaling','name','md.solidearth.settings.ocean_area_scaling','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','runfrequency','name','md.solidearth.settings.runfrequency','format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','degacc','name','md.solidearth.settings.degacc','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','timeacc','name','md.solidearth.settings.timeacc','format','Double','scale',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'fieldname','horiz','name','md.solidearth.settings.horiz','format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','computesealevelchange','name','md.solidearth.settings.computesealevelchange','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','sealevelloading','name','md.solidearth.settings.sealevelloading','format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','isgrd','name','md.solidearth.settings.isgrd','format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','glfraction','name','md.solidearth.settings.glfraction','format','Integer');
-		end % }}}
-		function savemodeljs(self,fid,modelname) % {{{
-		
-			writejsdouble(fid,[modelname '.slr.settings.maxiter'],self.maxiter);
-			writejsdouble(fid,[modelname '.slr.settings.reltol'],self.reltol);
-			writejsdouble(fid,[modelname '.slr.settings.abstol'],self.abstol);
-			writejsdouble(fid,[modelname '.slr.settings.rigid'],self.rigid);
-			writejsdouble(fid,[modelname '.slr.settings.elastic'],self.elastic);
-			writejsdouble(fid,[modelname '.slr.settings.rotation'],self.rotation);
-			writejsdouble(fid,[modelname '.slr.settings.ocean_area_scaling'],self.ocean_area_scaling);
-			writejsdouble(fid,[modelname '.slr.settings.run_frequency'],self.run_frequency);
-			writejsdouble(fid,[modelname '.slr.settings.degacc'],self.degacc);
-			writejsdouble(fid,[modelname '.slr.settings.glfraction'],self.glfraction);
+			WriteData(fid,prefix,'object',self,'fieldname','compute_bp_grd','name','md.solidearth.settings.compute_bp_grd','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','grdmodel','name','md.solidearth.settings.grdmodel','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','cross_section_shape','name','md.solidearth.settings.cross_section_shape','format','Integer');
 		end % }}}
 		function self = extrude(self,md) % {{{
 		end % }}}
+		function savemodeljs(self,fid,modelname) % {{{
+			% TODO: Update the following fields so that coverage is complete
+			writejsdouble(fid,[modelname '.solidearth.settings.maxiter'],self.maxiter);
+			writejsdouble(fid,[modelname '.solidearth.settings.reltol'],self.reltol);
+			writejsdouble(fid,[modelname '.solidearth.settings.abstol'],self.abstol);
+			writejsdouble(fid,[modelname '.solidearth.settings.selfattraction'],self.selfattraction);
+			writejsdouble(fid,[modelname '.solidearth.settings.elastic'],self.elastic);
+			writejsdouble(fid,[modelname '.solidearth.settings.viscous'],self.viscous);
+			writejsdouble(fid,[modelname '.solidearth.settings.rotation'],self.rotation);
+			writejsdouble(fid,[modelname '.solidearth.settings.grdocean'],self.rotation);
+			writejsdouble(fid,[modelname '.solidearth.settings.ocean_area_scaling'],self.ocean_area_scaling);
+			writejsdouble(fid,[modelname '.solidearth.settings.run_frequency'],self.run_frequency);
+			writejsdouble(fid,[modelname '.solidearth.settings.degacc'],self.degacc);
+			writejsdouble(fid,[modelname '.solidearth.settings.timeacc'],self.timeacc);
+			writejsdouble(fid,[modelname '.solidearth.settings.cross_section_shape'],self.cross_section_shape);
+		end % }}}
 	end
 end
Index: issm/trunk/src/m/classes/solidearthsettings.py
===================================================================
--- issm/trunk/src/m/classes/solidearthsettings.py	(revision 25994)
+++ issm/trunk/src/m/classes/solidearthsettings.py	(revision 26744)
@@ -13,47 +13,56 @@
     """
 
-    def __init__(self, *args):  #{{{
+    def __init__(self, *args):  # {{{
         self.reltol                 = 0
         self.abstol                 = 0
         self.maxiter                = 0
-        self.rigid                  = 0
-        self.elastic                = 0
-        self.rotation               = 0
+        self.selfattraction         = 1
+        self.elastic                = 1
+        self.viscous                = 1
+        self.rotation               = 1
+        self.grdocean               = 1
         self.ocean_area_scaling     = 0
         self.runfrequency           = 1 # How many time steps we skip before we run grd_core
-        self.computesealevelchange  = 1 # Will grd_core compute sea level?
-        self.isgrd                  = 1 # Will GRD patterns be computed?
+        self.sealevelloading        = 1 # Will sea-level loads be computed?
+        self.isgrd                  = 0 # Will GRD patterns be computed?
+        self.compute_bp_grd         = 0 # Will GRD patterns for bottom pressures be computed?
         self.degacc                 = 0 # Degree increment for resolution of Green tables
-        self.horiz                  = 0 # Compute horizontal displacement?
-        self.glfraction             = 1 # Barystatic contribution: full or fractional (default: fractional)
+        self.timeacc                = 0 # Time step accuracy required to compute Green tables
+        self.horiz                  = 0 # Compute horizontal deformation?
+        self.grdmodel               = 0 # GRD model (0 by default, 1 for (visco-)elastic, 2 for Ivins)
+        self.cross_section_shape    = 0 # Cross section only used when GRD model is Ivins
 
-        nargin = len(args)
-
-        if nargin == 0:
+        if len(args) == 0:
             self.setdefaultparameters()
         else:
             raise Exception('constructor not supported')
-    #}}}
+    # }}}
 
-    def __repr__(self): # {{{
+    def __repr__(self):  # {{{
         s = '   solidearth settings:\n'
-        s += '{}\n'.format(fielddisplay(self, 'reltol', 'sea level rise relative convergence criterion, (default, NaN: not applied)'))
-        s += '{}\n'.format(fielddisplay(self, 'abstol', 'sea level rise absolute convergence criterion, NaN: not applied'))
+        s += '{}\n'.format(fielddisplay(self, 'reltol', 'sea level change relative convergence criterion (default, NaN: not applied)'))
+        s += '{}\n'.format(fielddisplay(self, 'abstol', 'sea level change absolute convergence criterion (default, NaN: not applied)'))
         s += '{}\n'.format(fielddisplay(self, 'maxiter', 'maximum number of nonlinear iterations'))
-        s += '{}\n'.format(fielddisplay(self, 'ocean_area_scaling', 'correction for model representation of ocean area [default: No correction]'))
-        s += '{}\n'.format(fielddisplay(self, 'computesealevelchange', 'compute sealevel change from GRD in addition to steric?) default 0'))
+        s += '{}\n'.format(fielddisplay(self, 'grdocean', 'does this planet have an ocean, if set to 1: global water mass is conserved in GRD module (default: 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'ocean_area_scaling', 'correction for model representation of ocean area (default: No correction)'))
+        s += '{}\n'.format(fielddisplay(self, 'sealevelloading', 'enables surface loading from sea-level change (default: 1)'))
         s += '{}\n'.format(fielddisplay(self, 'isgrd', 'compute GRD patterns (default: 1'))
+        s += '{}\n'.format(fielddisplay(self, 'compute_bp_grd', 'compute GRD patterns for bottom pressure loads (default 1)'))
         s += '{}\n'.format(fielddisplay(self, 'runfrequency', 'how many time steps we skip before we run solidearthsettings solver during transient (default: 1)'))
-        s += '{}\n'.format(fielddisplay(self, 'rigid', 'rigid earth graviational potential perturbation'))
-        s += '{}\n'.format(fielddisplay(self, 'elastic', 'elastic earth graviational potential perturbation'))
-        s += '{}\n'.format(fielddisplay(self, 'degacc', 'accuracy (default .01 deg) for numerical discretization of the Green\'s functions'))
-        s += '{}\n'.format(fielddisplay(self, 'glfraction', 'contribute fractionally (default, 1) to barystatic sea level'))
+        s += '{}\n'.format(fielddisplay(self, 'selfattraction', 'enables surface mass load to perturb the gravity field'))
+        s += '{}\n'.format(fielddisplay(self, 'elastic', 'enables elastic deformation from surface loading'))
+        s += '{}\n'.format(fielddisplay(self, 'viscous', 'enables viscous deformation from surface loading'))
+        s += '{}\n'.format(fielddisplay(self, 'rotation', 'enables polar motion to feedback on the GRD fields'))
+        s += '{}\n'.format(fielddisplay(self, 'degacc', 'accuracy (default: .01 deg) for numerical discretization of the Green\'s functions'))
+        s += '{}\n'.format(fielddisplay(self, 'timeacc', 'time accuracy (default: 1 year) for numerical discretization of the Green\'s functions'))
+        s += '{}\n'.format(fielddisplay(self, 'grdmodel', 'type of deformation model, 0 for no GRD, 1 for spherical GRD model (SESAW model), 2 for half-space planar GRD (visco-elastic model from Ivins)'))
+        s += '{}\n'.format(fielddisplay(self, 'cross_section_shape', '1: square-edged (default). 2: elliptical. See iedge in GiaDeflectionCore'))
         return s
-    #}}}
+    # }}}
 
-    def setdefaultparameters(self): # {{{
+    def setdefaultparameters(self):  # {{{
         # Convergence criterion: absolute, relative, and residual
-        self.reltol = 0.01 # 1 percent
-        self.abstol = np.nan # default
+        self.reltol = 0.01  # 1 percent
+        self.abstol = np.nan  # default
 
         # Maximum of non-linear iterations
@@ -61,27 +70,35 @@
 
         # Computational flags
-        self.rigid = 1
+        self.selfattraction = 1
         self.elastic = 1
+        self.viscous = 1
         self.rotation = 1
+        self.grdocean = 1
         self.ocean_area_scaling = 0
-        self.isgrd = 1
-        self.computesealevelchange = 1
+        self.compute_bp_grd = 0
+        self.isgrd = 0
+        self.sealevelloading = 1
 
         # Numerical discretization accuracy
-        self.degacc = .01
+        self.degacc = 0.01
+        self.timeacc = 1
 
         # How many time steps we skip before we run solidearthsettings solver during transient
         self.runfrequency = 1
 
-        # Fractional contribution
-        self.glfraction = 1
-
         # Horizontal displacement? (not on by default)
         self.horiz = 0
-    #}}}
 
-    def checkconsistency(self, md, solution, analyses): # {{{
-        if ('SealevelriseAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslr):
+        # Cross section for Ivins model
+        self.cross_section_shape = 1 # Square as default (see iedge in GiaDeflectionCorex)
+
+        # No GRD model by default
+        self.grdmodel = 0
+    # }}}
+
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if ('SealevelchangeAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslc):
             return md
+
         md = checkfield(md, 'fieldname', 'solidearth.settings.reltol', 'size', [1])
         md = checkfield(md, 'fieldname', 'solidearth.settings.abstol', 'size', [1])
@@ -89,42 +106,53 @@
         md = checkfield(md, 'fieldname', 'solidearth.settings.runfrequency', 'size', [1], '>=', 1)
         md = checkfield(md, 'fieldname', 'solidearth.settings.degacc', 'size', [1], '>=', 1e-10)
+        md = checkfield(md, 'fieldname', 'solidearth.settings.timeacc', 'size', [1], '>', 0)
         md = checkfield(md, 'fieldname', 'solidearth.settings.horiz', 'NaN', 1, 'Inf', 1, 'values', [0, 1])
-        md = checkfield(md, 'fieldname', 'solidearth.settings.glfraction', 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'solidearth.settings.grdmodel', '>=', 0, '<=', 2)
+        md = checkfield(md, 'fieldname', 'solidearth.settings.cross_section_shape', 'numel', [1], 'values', [1, 2])
 
-        # Checks on computational flags
-        if self.elastic and not self.rigid:
-            raise Exception('solidearthsettings checkconsistency error message: need rigid on if elastic flag is set')
+        if self.elastic and not self.selfattraction:
+            raise Exception('solidearthsettings checkconsistency error message: need selfattraction on if elastic flag is set')
+        if self.viscous and not self.elastic:
+            raise Exception('solidearthsettings checkconsistency error message: need elastic on if viscous flag is set')
 
-        # A coupler to planet model is provided
+        # A GRD computation has been requested, make some checks on the nature of the meshes provided
         if self.isgrd:
-            if md.transient.iscoupler:
-                # We are good
-                pass
+            if md.mesh.__class__.__name__ == 'mesh3dsurface':
+                if self.grdmodel == 2:
+                    raise RuntimeException('model requires a 2D mesh to run gia Ivins computations (change mesh from mesh3dsurface to mesh2d)')
             else:
-                if md.mesh.__class__.__name__ == 'mesh3dsurface':
-                    # We are good
-                    pass
-                else:
-                    raise Exception('model is requesting sealevel computations without being a mesh3dsurface, or being coupled to one!')
+                if self.grdmodel == 1:
+                    raise RuntimeException('model requires a 3D surface mesh to run GRD computations (change mesh from mesh2d to mesh3dsurface)')
+            if self.sealevelloading and not self.grdocean:
+                raise RuntimeException('solidearthsettings checkconsistency error message: need grdocean on if sealevelloading flag is set')
+
+        if self.compute_bp_grd and not md.solidearth.settings.isgrd:
+            raise RuntimeException('solidearthsettings checkconsistency error message; if bottom pressure grd patterns are requested, solidearth settings class should have isgrd flag on')
+
         return md
-    #}}}
+    # }}}
 
-    def marshall(self, prefix, md, fid): #{{{
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'reltol', 'name', 'md.solidearth.settings.reltol', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'abstol', 'name', 'md.solidearth.settings.abstol', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'maxiter', 'name', 'md.solidearth.settings.maxiter', 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'rigid', 'name', 'md.solidearth.settings.rigid', 'format', 'Boolean')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'elastic', 'name', 'md.solidearth.settings.elastic', 'format', 'Boolean')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'rotation', 'name', 'md.solidearth.settings.rotation', 'format', 'Boolean')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'ocean_area_scaling', 'name', 'md.solidearth.settings.ocean_area_scaling', 'format', 'Boolean')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'runfrequency', 'name', 'md.solidearth.settings.runfrequency', 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'degacc', 'name', 'md.solidearth.settings.degacc', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'horiz', 'name', 'md.solidearth.settings.horiz', 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'computesealevelchange', 'name', 'md.solidearth.settings.computesealevelchange', 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname','isgrd', 'name', 'md.solidearth.settings.isgrd', 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname','glfraction', 'name', 'md.solidearth.settings.glfraction', 'format', 'Integer')
-    #}}}
+    def marshall(self, prefix, md, fid):  # {{{
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'reltol', 'name', 'md.solidearth.settings.reltol', 'format', 'Double');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'abstol', 'name', 'md.solidearth.settings.abstol', 'format', 'Double');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'maxiter', 'name', 'md.solidearth.settings.maxiter', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'selfattraction', 'name', 'md.solidearth.settings.selfattraction', 'format', 'Boolean');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'elastic', 'name', 'md.solidearth.settings.elastic', 'format', 'Boolean');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'viscous', 'name', 'md.solidearth.settings.viscous', 'format', 'Boolean');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'rotation', 'name', 'md.solidearth.settings.rotation', 'format', 'Boolean');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'grdocean', 'name', 'md.solidearth.settings.grdocean', 'format', 'Boolean');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'ocean_area_scaling', 'name', 'md.solidearth.settings.ocean_area_scaling', 'format', 'Boolean');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'runfrequency', 'name', 'md.solidearth.settings.runfrequency', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'degacc', 'name', 'md.solidearth.settings.degacc', 'format', 'Double');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'timeacc', 'name', 'md.solidearth.settings.timeacc', 'format', 'Double', 'scale', md.constants.yts);
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'horiz', 'name', 'md.solidearth.settings.horiz', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'sealevelloading', 'name', 'md.solidearth.settings.sealevelloading', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'isgrd', 'name', 'md.solidearth.settings.isgrd', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'compute_bp_grd', 'name', 'md.solidearth.settings.compute_bp_grd', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'grdmodel', 'name', 'md.solidearth.settings.grdmodel', 'format', 'Integer');
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'cross_section_shape', 'name', 'md.solidearth.settings.cross_section_shape', 'format', 'Integer');
+    # }}}
 
-    def extrude(self, md): #{{{
+    def extrude(self, md):  # {{{
         return self
-    #}}}
+    # }}}
